Skip to main content
Use the W&B Python SDK to construct artifacts from W&B Runs. You can add files, directories, URIs, and files from parallel runs to artifacts. After you add a file to an artifact, save the artifact to the W&B Server or your own private server. Each artifact is associated with a run. For information on how to track external files, such as files stored in Amazon S3, see the Track external files page.

Construct an artifact

Construct a W&B Artifact in three steps:
  1. Create an artifact Python object with wandb.Artifact()
  2. Add one or more files to the artifact
  3. Save your artifact to the W&B server

Create an artifact Python object with wandb.Artifact()

Initialize the wandb.Artifact() class to create an artifact object. Specify the following parameters:
  • Name: The name of your artifact. The name should be unique, descriptive, and memorable.
  • Type: The type of artifact. The type should be simple, descriptive, and correspond to a single step of your machine learning pipeline. Common artifact types include 'dataset' or 'model'.
W&B uses the “name” and “type” you provide to create a directed acyclic graph in the W&B App. See the Explore and traverse artifact graphs for more information.
Artifacts can not have the same name, regardless of type. In other words, you can not create an artifact named cats of type dataset and another artifact with the same name of type model.
You can optionally provide a description and metadata when you initialize an artifact object. For more information on available attributes and parameters, see the wandb.Artifact Class definition in the Python SDK Reference Guide. Copy and paste the following code snippet to create an artifact object. Replace the <name> and <type> placeholders with your own values:

Add one or more files to the artifact

Add files, directories, external URI references (such as Amazon S3) and more to your artifact object. To add a single file, use the artifact object’s Artifact.add_file() method:
To add a directory, use the Artifact.add_dir() method:
See the next section, Add files to an artifact, for more information on how to add different file types to an artifact.

Save your artifact to the W&B server

Save your artifact to the W&B server. Use the run object’s wandb.Run.log_artifact() method to save the artifact.
When to use to use wandb.Run.log_artifact() or Artifact.save()
  • Use wandb.Run.log_artifact() to create a new artifact and associate it with a specific run.
  • Use Artifact.save() to update an existing artifact without creating a new run.
Putting this all together, the following code snippet demonstrates how to create a dataset artifact, add a file to the artifact, and save the artifact to W&B:
Each time you log an artifact with the same name and type, W&B creates a new version of that artifact. For more information, see Create a new artifact version.
W&B performs calls wandb.Run.log_artifact() asynchronously for performant uploads. This can cause surprising behavior when logging artifacts in a loop. For example:
The artifact version v0 might not have an index of 0 in its metadata because artifacts may be logged in an arbitrary order.

Add files to an artifact

The following sections demonstrate how to add different types of objects to an artifact. Assume you have a directory with the following structure as you read through the examples:

Add a single file

Use wandb.Artifact.add_file() to add a single local file to an artifact. Provide the local path to the file as the local_path parameter:
For example, suppose you had a file called 'hello.txt' in your working local directory.
The artifact now has the following content:
Optionally, pass a different name to the name parameter to rename the file within the artifact object itself. Continuing the previous example:
The artifact is stored as:
The following table shows how different API calls produce different artifact contents:
API CallResulting artifact
artifact.new_file('hello.txt')hello.txt
artifact.add_file('model.h5')model.h5
artifact.add_file('checkpoints/model.h5')model.h5
artifact.add_file('model.h5', name='models/mymodel.h5')models/mymodel.h5

Add multiple files

Use the wandb.Artifact.add_dir() method to add multiple files from a local directory to an artifact. Provide the local path to the directory as the local_path parameter.
The following table show how different API calls produce different artifact contents:
API CallResulting artifact
artifact.add_dir('images')

cat.png

dog.png

artifact.add_dir('images', name='images')

images/cat.png

images/dog.png

Add a URI reference

Artifacts track checksums and other information for reproducibility if the URI has a scheme that the W&B library supports. Add an external URI reference to an artifact with the wandb.Artifact.add_reference() method. Replace the 'uri' string with your own URI. Optionally pass the desired path within the artifact for the name parameter.
Artifacts support the following URI schemes:
  • http(s)://: A path to a file accessible over HTTP. The artifact will track checksums in the form of etags and size metadata if the HTTP server supports the ETag and Content-Length response headers.
  • s3://: A path to an object or object prefix in S3. The artifact will track checksums and versioning information (if the bucket has object versioning enabled) for the referenced objects. Object prefixes are expanded to include the objects under the prefix, up to a maximum of 10,000 objects.
  • gs://: A path to an object or object prefix in GCS. The artifact will track checksums and versioning information (if the bucket has object versioning enabled) for the referenced objects. Object prefixes are expanded to include the objects under the prefix, up to a maximum of 10,000 objects.
The following table shows how different API calls produce different artifact contents:
API callResulting artifact contents
artifact.add_reference('s3://my-bucket/model.h5')model.h5
artifact.add_reference('s3://my-bucket/checkpoints/model.h5')model.h5
artifact.add_reference('s3://my-bucket/model.h5', name='models/mymodel.h5')models/mymodel.h5
artifact.add_reference('s3://my-bucket/images')

cat.png

dog.png

artifact.add_reference('s3://my-bucket/images', name='images')

images/cat.png

images/dog.png

Add files to artifacts from parallel runs

For large datasets or distributed training, multiple parallel runs might need to contribute to a single artifact.

Find path for logged artifacts and other metadata

The following code snippet shows how to use the W&B Public API to list the files in a run, including their names and URLs. Replace the <entity/project/run-id> placeholder with your own values:
See the File Class for more information on available attributes and methods.